SystemOrganization addCategory: #'Tp-TADP'!
SystemOrganization addCategory: #'Tp-TADP-Test'!
SystemOrganization addCategory: #'TP-TADP-METAP-TEST'!

Trait named: #ConPosicion
	uses: {}
	category: 'Tp-TADP'!

!ConPosicion methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 23:34'!
coincide: unElemento con: otroElemento
	unElemento = otroElemento ifTrue: [^1]. ^0! !

!ConPosicion methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:28'!
cuantosAciertosTiene: unaJugada
	^ self  posiciones inject: 0 into: [:acum :unaPosicion | acum + (self coincide: (unaJugada at: unaPosicion) con: (self ultimaJugadaGanadora at: unaPosicion))] ! !

Trait named: #Poceado
	uses: {}
	category: 'Tp-TADP'!

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:09'!
PorcentajeParaAgenciaGanadora
	self requirement! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:29'!
calculaCantidadDeJugadasConAciertos: numeroDeAciertos
	^ self apuestasEnJuego select: [ :unaApuesta | (self cuantosAciertosTiene: (unaApuesta jugada) ) = numeroDeAciertos ]! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:53'!
calculaGanadoresYRepartiPremios
	| primerPremio segundoPremio tercerPremio |
	
	self repartirAAgencias.
	
	primerPremio := self calculaCantidadDeJugadasConAciertos: (self mejorSituacion).
	segundoPremio := self calculaCantidadDeJugadasConAciertos: (self mejorSituacion - 1).
	tercerPremio := self calculaCantidadDeJugadasConAciertos: (self mejorSituacion - 2).
	
	self pagarA: primerPremio  conAciertos: (self mejorSituacion).
	self pagarA: segundoPremio  conAciertos: (self mejorSituacion - 1).
	self pagarA: tercerPremio  conAciertos: (self mejorSituacion - 2).
! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:59'!
mejorSituacion 
	self requirement! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:26'!
pagarA: apuestasGanadoras conAciertos: numeroDeAciertos
	apuestasGanadoras
		do: [ :apuesta | 
			apuesta agencia
				ganaste: (self pozo * (self porcentajePara: numeroDeAciertos) / apuestasGanadoras size) * self PorcentajeParaAgenciaGanadora]! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:06'!
porcentajePara: unNumero
	self requirement! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:16'!
pozo
	^ (self apuestasEnJuego size * self valorDeJugada)
	 ! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:30'!
premioDe: unaJugada
	^ self pozo * (self porcentajePara: (self cuantosAciertosTiene: unaJugada))! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:32'!
valorDeJugada 
	self requirement! !

Trait named: #SinPosicion
	uses: {}
	category: 'Tp-TADP'!

!SinPosicion methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:12'!
cuantosAciertosTiene: unaJugada
	^ unaJugada inject: 0 into: [ :acum :unNumero | acum + (self siEstaSumaUno: unNumero) ]! !

!SinPosicion methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:12'!
siEstaSumaUno: unNumero
	(self ultimaJugadaGanadora includes: unNumero)
		ifTrue: [ ^ 1 ]
		ifFalse: [ ^ 0 ]! !

TestCase subclass: #TestMetap4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP-TADP-METAP-TEST'!

!TestMetap4 methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/19/2012 11:30'!
ConvertirHerenciaAComp

| juegoPadre metapr loto |
juegoPadre := Juego new.
loto := Loto new.
self halt.
metapr := Metaprogramacion4 new.

metapr haceLaMagia: juegoPadre.

self assert:  loto parent equals:((juegoPadre instVarNamed: 'tipoDeJuego') class).! !

TestCase subclass: #TestsGenerales
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

TestCase subclass: #TestsLoto
	instanceVariableNames: 'apuestaLoto agenciaTota juegoLoto jugada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:23'!
testAgenciaGanaFijoPorJugada

	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	juegoLoto sorteame: #(5 6 7 8).
	
	self assert: agenciaTota caja equals: (2 * 0.12).! !

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:16'!
testCuantoGanaAgencia

	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(4 8 15 16 23 42).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	
	juegoLoto sorteame: jugada.
	
	self assert: agenciaTota caja equals: 0.28.! !

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:03'!
testCuantoGanaUnaApuesta
	
	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(4 8 15 16 23 42).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	
	juegoLoto sorteame: jugada.
	
	self assert: (juegoLoto premioDe: jugada) equals: 2*0.4.! !

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:31'!
testMeteLaApuestaEnColeccionDeApuestas

	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	
	self assert: (juegoLoto apuestasEnJuego size > 0).
	! !

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:08'!
testPozo

	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	
	juegoLoto sorteame: #(8).
	
	self assert: (juegoLoto pozo) equals:  2.! !

TestCase subclass: #TestsPagaOPaga
	instanceVariableNames: 'agenciaTota juegoPagaLPM jugada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

!TestsPagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:42'!
testCuantoGanaAgencia

	agenciaTota := Agencia new.
	juegoPagaLPM := PagaOPaga new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15).

	juegoPagaLPM apuesto: jugada en: agenciaTota conMonto: 100.
	
	juegoPagaLPM sorteame: jugada.
	
	self assert: agenciaTota caja equals: (337.5 * 0.1).! !

!TestsPagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:42'!
testCuantoGanaUnaApuesta 

	agenciaTota := Agencia new.
	juegoPagaLPM := PagaOPaga new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15).

	juegoPagaLPM apuesto: jugada en: agenciaTota conMonto: 100.
	
	juegoPagaLPM sorteame: jugada.
	
	self assert: (juegoPagaLPM premioDe: jugada conMonto: 100 ) equals: (337.5 * 0.7).! !

!TestsPagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:34'!
testMeteLaApuestaEnColeccionDeApuestas

	agenciaTota := Agencia new.
	juegoPagaLPM := PagaOPaga new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15).

	juegoPagaLPM apuesto: jugada en: agenciaTota conMonto: 100.
	
	self assert: juegoPagaLPM apuestasEnJuego size > 0.! !

TestCase subclass: #TestsProde
	instanceVariableNames: 'agenciaGanaRiver juegoProde jugada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

!TestsProde methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 23:38'!
testAgenciaGanaFijoPorJugada 

	agenciaGanaRiver := Agencia new.
	juegoProde := Prode new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(l v e l l l l l l l l e e ).
	
	juegoProde apuesto: jugada en: agenciaGanaRiver conMonto: 5.
	
	juegoProde sorteame: #(e e e e e e e e e e e e e).
	
	self assert: agenciaGanaRiver caja equals: (5*0.15) ! !

!TestsProde methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:16'!
testCuantoGanaAgencia
	
	agenciaGanaRiver := Agencia new.
	juegoProde := Prode new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(l v e l l l l l l l l e e ).
	
	juegoProde apuesto: jugada en: agenciaGanaRiver conMonto: 5.
	
	juegoProde sorteame: jugada.
	
	self assert: agenciaGanaRiver caja equals: ((5 * 0.15) + (5 * 0.5 * 0.05))! !

!TestsProde methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:14'!
testCuantoGanaUnaApuesta 

	agenciaGanaRiver := Agencia new.
	juegoProde := Prode new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(l v e l l l l l l l l e e ).
	
	juegoProde apuesto: jugada en: agenciaGanaRiver conMonto: 5.
	
	juegoProde sorteame: jugada.
	
	self assert: (juegoProde premioDe: jugada) equals: (5 * 0.5)! !

!TestsProde methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:37'!
testMeteLaApuestaEnColeccionDeApuestas

	agenciaGanaRiver  := Agencia new.
	juegoProde  := Prode new.
	jugada := OrderedCollection new.

	jugada addAll: #(l l l l l l e e e e e v v).

	juegoProde apuesto: jugada en: agenciaGanaRiver conMonto: 5.
	
	self assert: (juegoProde apuestasEnJuego size > 0).
	! !

!TestsProde methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 20:07'!
testPozo

	agenciaGanaRiver := Agencia new.
	juegoProde := Prode new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(1).
	
	juegoProde apuesto: jugada en: agenciaGanaRiver conMonto: 5.
	
	self assert: juegoProde pozo equals: 5.! !

TestCase subclass: #TestsQuini
	instanceVariableNames: 'agenciaTota juegoQuini jugada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

!TestsQuini methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:41'!
testAgenciaGanaFijoPorJugada

	agenciaTota := Agencia new.
	juegoQuini := Quiniela new.
	jugada := OrderedCollection new.

	"jugada es: (numero posicion)"

	jugada addAll: #(1412 2).

	juegoQuini apuesto: jugada en: agenciaTota conMonto: 100.
	
	juegoQuini sorteame: #().
	
	self assert: agenciaTota caja equals: (100 * 0.17)! !

!TestsQuini methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:41'!
testCuantoGanaAgencia 

	agenciaTota := Agencia new.
	juegoQuini := Quiniela new.
	jugada := OrderedCollection new.

	"jugada es: (numero posicion)"

	jugada addAll: #(1412 2).

	juegoQuini apuesto: jugada en: agenciaTota conMonto: 100.
	
	juegoQuini sorteame: #(0000 1412 3333 1010 4343 1212 8484 9999 1022 3833 5454 1463 7282 8254 7598 2512 8209 9412 6655 3333).
	
	self assert: agenciaTota caja equals: 100 * 0.17.! !

!TestsQuini methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:42'!
testCuantoGanaUnaApuesta 

	agenciaTota := Agencia new.
	juegoQuini := Quiniela new.
	jugada := OrderedCollection new.
		
	"jugada es: (numero posicion)"

	jugada addAll: #(1412 2).

	juegoQuini apuesto: jugada en: agenciaTota conMonto: 100.
	
	juegoQuini sorteame: #(0000 1412 3333 1010 4343 1212 8484 9999 1022 3833 5454 1463 7282 8254 7598 2512 8209 9412 6655 3333).
	
	self assert: (juegoQuini premioDe: jugada conMonto: 100) equals: 3500 * 100.! !

!TestsQuini methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:42'!
testMeteLaApuestaEnColeccionDeApuestas

	agenciaTota := Agencia new.
	juegoQuini := Quiniela new.
	jugada := OrderedCollection new.

	"jugada es: (numero posicion)"

	jugada addAll: #(1412 2).

	juegoQuini apuesto: jugada en: agenciaTota conMonto: 100.
	
	self assert: (juegoQuini apuestasEnJuego size > 0).
	! !

Object subclass: #Agencia
	instanceVariableNames: 'caja'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

!Agencia methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 03:23'!
caja
	^ caja! !

!Agencia methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 03:33'!
caja: anObject
	caja := anObject! !

!Agencia methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 03:34'!
ganaste: plata 
	self caja: caja + plata.! !

!Agencia methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 03:42'!
initialize
	self caja: 0! !

Object subclass: #Apuesta
	instanceVariableNames: 'jugada agencia monto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:37'!
agencia
	^ agencia.! !

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:37'!
agencia: unaAgencia
	agencia := unaAgencia.! !

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:37'!
jugada 
	^jugada! !

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:34'!
jugada: unaJugada 
	jugada := unaJugada.! !

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:41'!
monto 
	^ monto! !

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:41'!
monto: unMonto
	monto := unMonto! !

Object subclass: #Juego
	instanceVariableNames: 'apuestasEnJuego ultimaJugadaGanadora'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:42'!
apuestasEnJuego
	^ apuestasEnJuego.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 19:30'!
apuesto: unaJugada en: unaAgencia conMonto: unNumero
		| unaApuesta |
	unaApuesta := Apuesta new.
	unaApuesta jugada: unaJugada.
	unaApuesta agencia: unaAgencia.
	unaApuesta monto: unNumero.
	
	self apuestasEnJuego add: unaApuesta.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:49'!
calculaGanadoresYRepartiPremios
	self subclassResponsibility ! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:43'!
initialize 			
	apuestasEnJuego := OrderedCollection new.
		
		! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:40'!
repartirAAgencias
	apuestasEnJuego do: [ :unaApuesta | unaApuesta agencia ganaste: (unaApuesta monto * self PorcentajeFijoPorJugada) ]! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:49'!
sorteame: unaJugada
	self ultimaJugadaGanadora: unaJugada.
	self calculaGanadoresYRepartiPremios.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:48'!
ultimaJugadaGanadora
	^ ultimaJugadaGanadora.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:57'!
ultimaJugadaGanadora: jugadaGanadora
	 ultimaJugadaGanadora := jugadaGanadora.! !

Juego subclass: #Loto
	uses: Poceado + SinPosicion
	instanceVariableNames: ''
	classVariableNames: 'PorcentajeFijoPorJugada PorcentajeParaAgenciaGanadora'
	poolDictionaries: ''
	category: 'Tp-TADP'!

Loto class
	uses: Poceado classTrait + SinPosicion classTrait
	instanceVariableNames: ''!

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:37'!
PorcentajeFijoPorJugada
	^ 0.12! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:09'!
PorcentajeParaAgenciaGanadora
	^ 0.05! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:10'!
cuantosAciertosTiene: unaJugada
	^ unaJugada inject: 0 into: [ :acum :unNumero | acum + (self siEstaSumaUno: unNumero) ]! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:43'!
initialize 
	super initialize.! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:43'!
mejorSituacion 
	^ 6! !

!Loto methodsFor: 'accessing' stamp: 'BrunoFischetti 9/14/2012 00:07'!
porcentajePara: unNumero
	unNumero == 6 ifTrue: [^0.4].
	unNumero == 5 ifTrue: [^0.17].
	unNumero == 4 ifTrue: [^0.05].! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:57'!
valorDeJugada 
	^ 2.! !

Juego subclass: #PagaOPaga
	uses: SinPosicion
	instanceVariableNames: ''
	classVariableNames: 'PorcentajeAgenciaGanadora PorcentajeJugadorGanador'
	poolDictionaries: ''
	category: 'Tp-TADP'!

PagaOPaga class
	uses: SinPosicion classTrait
	instanceVariableNames: ''!

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:29'!
PorcentajeAgenciaGanadora
	^ 0.1! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:39'!
PorcentajeJugadorGanador
	^ 0.7! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:45'!
calculaGanadoresYRepartiPremios
	self apuestasEnJuego
		do: [ :unaApuesta | 
			unaApuesta agencia
				ganaste: ((self premioDe: unaApuesta jugada conMonto: unaApuesta monto) * self PorcentajeAgenciaGanadora) / self PorcentajeJugadorGanador ]! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:44'!
initialize 
	super initialize.! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:39'!
premioDe: unaJugada conMonto: unMonto
	^ ((self cuantosAciertosTiene: unaJugada) / 10 raisedTo: 3) * unMonto * self PorcentajeJugadorGanador! !

Juego subclass: #Prode
	uses: Poceado + ConPosicion
	instanceVariableNames: ''
	classVariableNames: 'PorcentajeFijoPorJugada PorcentajeParaAgenciaGanadora'
	poolDictionaries: ''
	category: 'Tp-TADP'!

Prode class
	uses: Poceado classTrait + ConPosicion classTrait
	instanceVariableNames: ''!

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 19:32'!
PorcentajeFijoPorJugada
	^ 0.15! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 23:54'!
PorcentajeParaAgenciaGanadora
	^ 0.05! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:44'!
initialize 
	super initialize.! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:50'!
mejorSituacion 
	^ 13! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:25'!
pagarA: apuestasGanadoras conAciertos: numeroDeAciertos
	
	self mejorSituacion = numeroDeAciertos ifTrue: [
	
	apuestasGanadoras
		do: [ :apuesta | 
			apuesta agencia
				ganaste: (self pozo * (self porcentajePara: numeroDeAciertos) / apuestasGanadoras size) * self PorcentajeParaAgenciaGanadora]
			
		]! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:50'!
porcentajePara: unNumero
	unNumero == 13 ifTrue: [^0.5].
	unNumero == 12 ifTrue: [^0.35].
	unNumero == 11 ifTrue: [^0.11].! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 23:25'!
posiciones 
	^ #(1 2 3 4 5 6 7 8 9 10 11 12 13)! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:51'!
valorDeJugada 
	^ 5! !

Juego subclass: #Quiniela
	uses: ConPosicion
	instanceVariableNames: ''
	classVariableNames: 'PorcentajeFijoPorJugada'
	poolDictionaries: ''
	category: 'Tp-TADP'!

Quiniela class
	uses: ConPosicion classTrait
	instanceVariableNames: ''!

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:42'!
PorcentajeFijoPorJugada
	^ 0.17! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:06'!
acertoCon: unaJugada
	^ self coincide: (unaJugada first) con: ((self ultimaJugadaGanadora at: unaJugada second) \\ (self porCuantoSeTieneQueDividir: unaJugada first))! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:33'!
calculaGanadoresYRepartiPremios
	
	self repartirAAgencias.
	! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:49'!
cantidadCifrasPara: unNumero
	(unNumero / 1000) >= 1 ifTrue: [^4].
	(unNumero / 100) >= 1 ifTrue: [^3].
	(unNumero / 10) >= 1 ifTrue: [^2].
	^1.
	! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:44'!
initialize 
	super initialize.! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:44'!
multiplicadorCorrespondienteParaCifrasDe: unaJugada
	| numero |
	numero := self cantidadCifrasPara: (unaJugada first).
	
	numero = 4 ifTrue: [^3500].
	numero = 3 ifTrue: [^500].
	numero = 2 ifTrue: [^70].
	numero = 1 ifTrue: [^7]! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:06'!
porCuantoSeTieneQueDividir: unNumero
	| numero |
	numero := self cantidadCifrasPara: unNumero. 
	
	numero = 4 ifTrue: [^10000].
	numero = 3 ifTrue: [^1000].
	numero = 2 ifTrue: [^100].
	numero = 1 ifTrue: [^10]! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:37'!
premioDe: unaJugada conMonto: unMonto
	^ (self multiplicadorCorrespondienteParaCifrasDe: unaJugada) * (unMonto) * ( self acertoCon: unaJugada)! !

Object subclass: #Metaprogramacion4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

!Metaprogramacion4 methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/19/2012 11:16'!
cambiarPadre: padre

padre subclasses: [:unaClase | unaClase parent: ((padre instVarNamed: 'tipoDeJuego') class)].



! !

!Metaprogramacion4 methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/19/2012 10:30'!
crearNuevaClase 

        Object subclass: #TipoDeJuego
    	    instanceVariableNames: ''
	    classVariableNames: ''
    	    poolDictionaries: ''
	    category:  'Tp-TADP'! !

!Metaprogramacion4 methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/19/2012 10:42'!
crearVarInstancia: padre
padre class addInstVarNamed: 'tipoDeJuego'. ! !

!Metaprogramacion4 methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/19/2012 11:28'!
haceLaMagia: padre

self halt.
self crearVarInstancia: padre.
padre instVarNamed: 'tipoDeJuego' put: ((self crearNuevaClase) new).
self cambiarPadre: padre. 



! !
